/*
 * sonar.h
 *
 * SONAR Client Library version 0
 *
 * Jason Cox
 *
 */


struct sonar_info {
    unsigned int host;
    unsigned int metric;
};


/*
 * Where the host address for the SONAR server is located.
 * These are in the order they are checked. (ie. a SONAR_SERVER
 * environment variable will override a server address in ~/.sonar-server)
 */
#define SONAR_ENV_NAME    "SONAR_SERVER"
#define SONAR_RCFILE      "/.sonar-server"
#define SONAR_FILE        "/etc/sonar-server"
#define SONAR_HOST_NAME   "sonar-server"


/*
 * The return values for sonar_probe()
 */
#define SONAR_SUCCESS     0x80000000
#define SONAR_BADVER      0xc0000000
#define SONAR_TOOBUSY     0xc0000001
#define SONAR_BADREQ      0xc0000002
#define SONAR_ERROR        -1
#define SONAR_TIMEDOUT     -2
#define SONAR_NOSERVER     -3


/* Internal stuff */
#define SONAR_VERSION     0
#define SONAR_PORT        572
#define MAX_SONAR_REQS    185


#ifdef __STDC__
#define ANSI(x) x
#else
#define ANSI(x) ()
#endif


int sonar_init ANSI((char *));
int sonar_probe ANSI((struct sonar_info *, int *, unsigned int, unsigned int));
int sonar_cmp ANSI((struct sonar_info *, struct sonar_info *));
