#include "client.h"

/*
 * This file contains routines that deal with the client waiting list.
 */

static Client freelist = NULL;

Client
client_create(num)
unsigned int num;
{
    Client x;
    unsigned int i;

    x = (Client) malloc(sizeof(struct client) * (num + 1));
    if (!x) {
	fprintf(stderr, "Out of memory!\n");
	exit(1);
    }

    for (i=1; i < num+1; i++)
	x[i].next = &x[i+1];

    x[num].next = NULL;
    freelist = &x[1];

    x->next = x->prev = x;
    return x;
}


void
client_insert(list, node)
Client list,
       node;
{
    Client x;

    for (x = list->next; x != list && tvgte(&(node->timeout), &(x->timeout));
	 x = x->next);

    node->next = x;
    node->prev = x->prev;
    x->prev->next = node;
    x->prev = node;
}


void
client_delete(node)
Client node;
{
    node->next->prev = node->prev;
    node->prev->next = node->next;

    client_free(node);
}


Client
client_getnode()
{
    Client x;

    x = freelist;

    if (x)
	freelist = x->next;

    return x;
}


void
client_free(node)
Client node;
{
    node->next = freelist;
    freelist = node;
}
