#define SONAR_PORT 572

#define MAX_PACK_REQS 185      /* Max requests in one packet     */
#define MAX_CLIENTS 100       /* Max clients that can be queued */


#define CONFIG_FILE "/etc/sonardrc" /* Name of the sonar config file */
#define MAX_DB_ENTRIES 5000    /* Max hosts that can be in the data base.
				  This number should be larger than
				  MAX_PACK_REQS * MAX_CLIENTS or sonar
				  will perform badly under extreme
				  operation.                             */
#define HASH_TABLE_SIZE 2500   /* Size of the chained hash table holding
                                  the host database.  Watch out for large
				  load factors based on the value of
				  MAX_DB_ENTRIES.                        */



#define HOST_INFO_TIMEOUT 21600/* The valid time-span for host data obtained */
#define HOST_UNREACH_TIMEOUT 1800
#define MAX_WAIT 300  /* Maximum time that a client can wait */

#define SIZE_ICMP_HDR      8    /* 8-byte ICMP header */

#define SONAR_REQUEST      0
#define SONAR_SUCCESS      0x80000000
#define VERSION_MISMATCH   0xc0000000
#define TOO_BUSY           0xc0000001
#define BAD_REQUEST        0xc0000002
#define REQUEST            0
#define SONAR_VERSION      0
#define SONAR_LOW_VERSION  0
#define BAD_PACKET         2000
