#ifndef HASH_H
#define HASH_H

#include "header.h"
#include "client_update.h"



typedef struct hash_node {
    unsigned int host;
    unsigned int metric;
    int time_obtained;
    Client_update clients_waiting;

    struct hash_node *lru_next;
    struct hash_node *lru_prev;
    struct hash_node *hash_next;
    struct hash_node *hash_prev;
} *Hash_node;



typedef struct hash {
    int size;
    struct hash_node *hash;

    int free_size;
    struct hash_node *free;

    struct hash_node *lru_chain;
} *Hash;



Hash hash_create ANSI((int, int));
void hash_insert ANSI((Hash, unsigned int, Hash_node));
Hash_node hash_find ANSI((Hash, unsigned int, unsigned int));
Hash_node hash_getnode ANSI((Hash));
void hash_free ANSI((Hash, Hash_node));
unsigned int hash_index ANSI((unsigned int));

#define OUTSTANDING_PING(n) (n->time_obtained == 0)
#define SET_OUTSTANDING_PING(n) n->time_obtained = 0

#endif
