#include "mask.h"


/*
 * masklist_create
 *
 * Description: This function initializes a linked list and returns the
 *              head node.
 *
 */
Masklist
masklist_create()
{
    Masklist list;

    list = (Masklist) malloc(sizeof(struct masklist));
    list->mask = 0;
    list->next = list;
    return list;
}


/*
 * masklist_insert
 *
 * Description: This function takes a mask and the length of vaild bits
 *              in the mask and inserts them into the list.
 *
 */
void
masklist_insert(list, addr, mask)
Masklist list;
unsigned int addr;
unsigned int mask;
{
    Masklist node;

    node = (Masklist) malloc(sizeof(struct masklist));
    node->addr = addr;
    node->mask = mask;
    node->next = list->next;
    list->next = node;
}


/*
 * masktable_create
 *
 * Description: Initializes the masktable (which is used to get the
 *              correct position of bits for the different mask regions).
 *
 */
void
masktable_create()
{
    extern unsigned int masktable[32];
    int x;

    for (x = 1; x <= 32; x++)
	masktable[x] = htonl(0xffffffff << (32 - x));

    masktable[0] = 0;
}
