#include "respond.h"


/*
 * do_response  
 *
 * Description: This function looks up the metrics for the client and
 *              packs them into the response and fires off the response.
 *
 */
void do_response(s, client, clear)
int s;
Client client;
int clear;
{
    extern Hash host_data;
    
    Hash_node x;
    int i,cnt=0;
    char *z;

    *((int *)client->buf+1) = htonl(SONAR_SUCCESS);
    
    z=client->buf+16;
    
    for (i = 0 ; i < client->cnt ; i++) {
	x = hash_find(host_data, hash_index(client->reqs[i]), client->reqs[i]);
	if (x) {
	    if (x->time_obtained && x->metric) {
		/* valid info, i.e., not waiting for an answer */
		*((unsigned int *)z) = x->host;
		z+=4;
		*((unsigned int *)z) = htonl(x->metric);
		z+=4;
		cnt++;
	    }
	    if (clear)
		client_update_delete(&(x->clients_waiting), client);
	}
    }
    
    /* stick in the count */
    *((unsigned int *)(client->buf+12)) = htonl(cnt);

    i = 16 + (cnt*8);
    if (i != sendto(s, client->buf, i, 0, (struct sockaddr *)&(client->addr),
		    client->repl_ln))
	perror("sendto");
}


/*
 * expire_clients
 *
 * Description: This function goes through the client waiting list,
 *              removes and sends responses to clients that are older
 *              than the time in timeval
 *
 */
void expire_clients(tv, s)
struct timeval *tv;
int s;
{
    extern Client clients;
    Client tmp, next;

    tmp = FIRST_CLIENT;
    while (tmp != clients && tvgte(tv, &(tmp->timeout))) {
	next = tmp->next;
	do_response(s, tmp, 1);
	client_delete(tmp);
	tmp = next;
    }
}
