#include "sonard.h"

int ident;
int packsize;
struct sockaddr_in dest;
u_char sendpack[64];
int icmp_sock;
int udp_sock;
int sockaddr_in_size;

Client clients;      /* Timeout keyed sorted list of client requests */
Hash host_data;      /* Saved host metrics */
Masklist query_mask = NULL;
unsigned int masktable[33];
int *broadcast_addrs;

int main(argc, argv)
int argc;
char **argv;
{ 
    struct timeval tv, tv2, *ptv;
    fd_set read_fds, read_fds_master;
    char *ptr, *ptr2, *name;
    int len;

    name = argv[0];

    while (--argc) {
	argv++;
	
	if (**argv == '-') {
	    switch (argv[0][1]) {
	      case 'm':
		if (query_mask == NULL) {
		    masktable_create();
		    query_mask = masklist_create();
		}
		if (!(ptr=strtok(&argv[0][2],"/"))|| !(ptr2=strtok(NULL,"/"))){
		    fprintf(stderr, "%s: Bad mask\n", name);
		    exit(1);
		}
		sscanf(ptr2, "%d", &len);
		if (len > 32 || len < 0) {
		    fprintf(stderr, "%s: %d: Invalid mask length\n",name,len);
		    exit(1);
		}
		masklist_insert(query_mask, inet_addr(ptr), masktable[len]);
		break;

		
	      case 'v':
		printf("SONAR Protocol Version %d\n", SONAR_VERSION);
		exit(0);

		
	      default:
		fprintf(stderr, "usage: %s [-v] [-mmaddr/mask]\n", name);
		exit(1);
	    }
	}
	else {
	    fprintf(stderr, "usage: %s [-v] [-maddr/mask]\n", name);
	    exit(1);
	}
    }
    
    initialize();
    
#ifndef _DEBUG_
    if (fork())	exit(0);
#endif
    
    FD_ZERO(&read_fds_master);
    FD_SET(icmp_sock,&read_fds_master);
    FD_SET(udp_sock,&read_fds_master);
    
    while (1) {
	read_fds = read_fds_master;

	/* Timeout clients */
	if (THERE_ARE_CLIENTS) {
	    gettimeofday(&tv, NULL);
	    if (tvgte(&tv,&(FIRST_CLIENT->timeout)))
		expire_clients(&tv, udp_sock);
	}
	
	/* Get a new timeout value */
	if (THERE_ARE_CLIENTS) {
	    gettimeofday(&tv2, NULL);
	    tv.tv_sec = FIRST_CLIENT->timeout.tv_sec;
	    tv.tv_usec = FIRST_CLIENT->timeout.tv_usec;
	    tvsub(&tv, &tv2);
	    ptv = &tv;
	}
	else
	    ptv = NULL;


	if (select(udp_sock + 1, &read_fds, NULL, NULL, ptv) < 0) {
	    if (errno != EINTR) {
		perror("Select");
		exit(errno);
	    }
	}
	
	if (FD_ISSET(icmp_sock, &read_fds))
	    recv_icmp(icmp_sock,udp_sock); 
	
	if (FD_ISSET(udp_sock, &read_fds))
	    recv_udp(udp_sock);
    }       
}
