/************************************************************* 


   FILE :   util.c 


   WRITTEN :  
         by     Stan Green 
         on     Jun 4, 1995



*************************************************************/ 


#include "util.h"



/************************************************************* 
 FUNCTION : tvsub  

 PURPOSE : Subtract 2 BSD timeval structs:  out = out - in.
           Modified from ping program.
         if in > out then out set to zero

 RETURNS : 


 VARIABLES : 

 NAME          LOCATION          DESCRIPTION 



*************************************************************/ 

void
tvsub(out, in)
register struct timeval *out; /* return value through pointer */
register struct timeval *in;
{
   if ( (out->tv_usec -= in->tv_usec) < 0) { /* subtract microsec */
      out->tv_sec--;
      out->tv_usec += 1000000;
   }
   out->tv_sec -= in->tv_sec; /* subtract seconds */

   if (out->tv_sec < 0 ) {
      out->tv_sec = out->tv_usec = 0;
   }
}

/*************************************************************
 FUNCTION : tvadd

 PURPOSE : Add 2 BSD timeval structs:  out = out + in.

 RETURNS :


 VARIABLES :

 NAME          LOCATION          DESCRIPTION



*************************************************************/

void tvadd(out, in)
register struct timeval *out; /* return value through pointer */
register struct timeval *in;
{
   out->tv_sec+=in->tv_sec;
   out->tv_usec += in->tv_usec;

   if (out->tv_usec >= 1000000) {
      out->tv_sec++;
      out->tv_usec-=1000000;
   }
}

/*************************************************************
 FUNCTION : tvgte

 PURPOSE : if out >= in return 1 else 0;

 RETURNS :


 VARIABLES :

 NAME          LOCATION          DESCRIPTION



*************************************************************/

int tvgte(out, in)
register struct timeval *out; /* return value through pointer */
register struct timeval *in;
{

   if (out->tv_sec < in->tv_sec)
      return 0;
   else {
      if (out->tv_sec > in->tv_sec) {
         return 1;
      } else {
         /* the seconds part are equal */
         if (out->tv_usec < in->tv_usec) {
            return 0;
         } else 
            return 1;
      }
   }
}

